"use strict";

var _babelTemplate = require("babel-template");

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function (_ref) {
  var t = _ref.types;

  var tmpl = (0, _babelTemplate2.default)("\n    (function(SUPER_INSIDE){\n      var CHILD_INSIDE_1 = CLASS_EXPRESSION\n      var CHILD_INSIDE_2 = CHILD_INSIDE_1\n      if (\"onInherited\" in SUPER_INSIDE) {\n        if (typeof SUPER_INSIDE.onInherited == 'function') {\n          CHILD_INSIDE_2 = SUPER_INSIDE.onInherited(CHILD_INSIDE_1) || CHILD_INSIDE_1;\n        } else {\n          throw new TypeError(\"Attempted to call onInherited, but it was not a function\");\n        }\n      }\n      if (typeof CHILD_INSIDE_2 == 'function') {\n        Object.defineProperty(CHILD_INSIDE_2, \"name\", { value: CHILD_NAME, configurable: true });\n      }\n      return CHILD_INSIDE_2;\n    })(SUPER_OUTSIDE)\n  ");

  function transform(childClassName, path) {
    var superClassName = path.node.superClass.name;

    var SUPER_INSIDE = path.scope.generateUidIdentifier(superClassName);
    var CHILD_INSIDE_1 = path.scope.generateUidIdentifier(childClassName);
    var CLASS_EXPRESSION = t.classExpression(null, SUPER_INSIDE, path.node.body, []);
    // Don't transform *this* class expression, or we'll loop forever
    CLASS_EXPRESSION.__babelPluginTransformClassInheritedHook_skip = true;
    var CHILD_INSIDE_2 = path.scope.generateUidIdentifier(childClassName);
    var CHILD_NAME = t.stringLiteral(childClassName);
    var SUPER_OUTSIDE = t.identifier(superClassName);

    return tmpl({
      CHILD_NAME: CHILD_NAME,
      SUPER_INSIDE: SUPER_INSIDE,
      CHILD_INSIDE_1: CHILD_INSIDE_1,
      CLASS_EXPRESSION: CLASS_EXPRESSION,
      CHILD_INSIDE_2: CHILD_INSIDE_2,
      SUPER_OUTSIDE: SUPER_OUTSIDE
    });
  }

  return {
    visitor: {
      "ClassDeclaration|ClassExpression": function ClassDeclarationClassExpression(path) {
        if (!path.node.superClass) return;
        if (path.node.__babelPluginTransformClassInheritedHook_skip) return;

        var childClassName;

        if (t.isIdentifier(path.node.id)) {
          childClassName = path.node.id.name;
        } else if (path.node.id == null && t.isVariableDeclarator(path.parentPath.node)) {
          childClassName = path.parentPath.node.id.name;
        }

        var expressionStatement = transform(childClassName, path);

        if (t.isClassDeclaration(path.node)) {
          path.replaceWith(t.variableDeclaration("var", [t.variableDeclarator(t.identifier(childClassName), expressionStatement.expression)]));
        } else if (t.isClassExpression(path.node)) {
          path.replaceWith(expressionStatement.expression);
        }
      }
    }
  };
};