'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _chai = require('chai');

var _chai2 = _interopRequireDefault(_chai);

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _sinonChai = require('sinon-chai');

var _sinonChai2 = _interopRequireDefault(_sinonChai);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_chai2.default.use(_sinonChai2.default);

describe('Class.onInherited', function () {
  describe("using class declarations", function () {
    it("is called when a class is inherited from", function () {
      var callback = _sinon2.default.spy();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            callback(child);
          }
        }]);
        return Parent;
      }();

      var Child = function (_Parent) {
        var _Child = function (_Parent2) {
          (0, _inherits3.default)(_Child, _Parent2);

          function _Child() {
            (0, _classCallCheck3.default)(this, _Child);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child).apply(this, arguments));
          }

          return _Child;
        }(_Parent);

        var _Child2 = _Child;

        if ("onInherited" in _Parent) {
          if (typeof _Parent.onInherited == 'function') {
            _Child2 = _Parent.onInherited(_Child) || _Child;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child2 == 'function') {
          Object.defineProperty(_Child2, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child2;
      }(Parent);

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("can redefine the value of the declared class", function () {
      var replacement = _sinon2.default.stub();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            return replacement;
          }
        }]);
        return Parent;
      }();

      var Child = function (_Parent3) {
        var _Child3 = function (_Parent4) {
          (0, _inherits3.default)(_Child3, _Parent4);

          function _Child3() {
            (0, _classCallCheck3.default)(this, _Child3);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child3).apply(this, arguments));
          }

          return _Child3;
        }(_Parent3);

        var _Child4 = _Child3;

        if ("onInherited" in _Parent3) {
          if (typeof _Parent3.onInherited == 'function') {
            _Child4 = _Parent3.onInherited(_Child3) || _Child3;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child4 == 'function') {
          Object.defineProperty(_Child4, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child4;
      }(Parent);

      (0, _chai.expect)(Child).to.equal(replacement);
    });

    it("has a reliable name property", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {}
        }]);
        return Parent;
      }();

      var Child = function (_Parent5) {
        var _Child5 = function (_Parent6) {
          (0, _inherits3.default)(_Child5, _Parent6);

          function _Child5() {
            (0, _classCallCheck3.default)(this, _Child5);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child5).apply(this, arguments));
          }

          return _Child5;
        }(_Parent5);

        var _Child6 = _Child5;

        if ("onInherited" in _Parent5) {
          if (typeof _Parent5.onInherited == 'function') {
            _Child6 = _Parent5.onInherited(_Child5) || _Child5;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child6 == 'function') {
          Object.defineProperty(_Child6, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child6;
      }(Parent);

      (0, _chai.expect)(Child.name).to.equal("Child");
    });
  });

  describe("using class expressions", function () {
    it("is called when a class is inherited from", function () {
      var callback = _sinon2.default.spy();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            callback(child);
          }
        }]);
        return Parent;
      }();

      var Child = function (_Parent7) {
        var _Child7 = function (_Parent8) {
          (0, _inherits3.default)(_Child7, _Parent8);

          function _Child7() {
            (0, _classCallCheck3.default)(this, _Child7);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child7).apply(this, arguments));
          }

          return _Child7;
        }(_Parent7);

        var _Child8 = _Child7;

        if ("onInherited" in _Parent7) {
          if (typeof _Parent7.onInherited == 'function') {
            _Child8 = _Parent7.onInherited(_Child7) || _Child7;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child8 == 'function') {
          Object.defineProperty(_Child8, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child8;
      }(Parent);

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("can redefine the value of the declared class", function () {
      var replacement = _sinon2.default.stub();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            return replacement;
          }
        }]);
        return Parent;
      }();

      var Child = function (_Parent9) {
        var _Child9 = function (_Parent10) {
          (0, _inherits3.default)(_Child9, _Parent10);

          function _Child9() {
            (0, _classCallCheck3.default)(this, _Child9);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child9).apply(this, arguments));
          }

          return _Child9;
        }(_Parent9);

        var _Child10 = _Child9;

        if ("onInherited" in _Parent9) {
          if (typeof _Parent9.onInherited == 'function') {
            _Child10 = _Parent9.onInherited(_Child9) || _Child9;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child10 == 'function') {
          Object.defineProperty(_Child10, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child10;
      }(Parent);

      (0, _chai.expect)(Child).to.equal(replacement);
    });

    it("has a reliable name property", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {}
        }]);
        return Parent;
      }();

      var Child = function (_Parent11) {
        var _Child11 = function (_Parent12) {
          (0, _inherits3.default)(_Child11, _Parent12);

          function _Child11() {
            (0, _classCallCheck3.default)(this, _Child11);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child11).apply(this, arguments));
          }

          return _Child11;
        }(_Parent11);

        var _Child12 = _Child11;

        if ("onInherited" in _Parent11) {
          if (typeof _Parent11.onInherited == 'function') {
            _Child12 = _Parent11.onInherited(_Child11) || _Child11;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child12 == 'function') {
          Object.defineProperty(_Child12, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child12;
      }(Parent);

      (0, _chai.expect)(Child.name).to.equal("Child");
    });
  });

  describe("classes without an onInherited callback", function () {
    it("still function properly", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'number',
          value: function number() {
            return 7;
          }
        }]);
        return Parent;
      }();

      var Child = function (_Parent13) {
        var _Child13 = function (_Parent14) {
          (0, _inherits3.default)(_Child13, _Parent14);

          function _Child13() {
            (0, _classCallCheck3.default)(this, _Child13);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child13).apply(this, arguments));
          }

          (0, _createClass3.default)(_Child13, null, [{
            key: 'letter',
            value: function letter() {
              return "A";
            }
          }]);
          return _Child13;
        }(_Parent13);

        var _Child14 = _Child13;

        if ("onInherited" in _Parent13) {
          if (typeof _Parent13.onInherited == 'function') {
            _Child14 = _Parent13.onInherited(_Child13) || _Child13;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child14 == 'function') {
          Object.defineProperty(_Child14, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child14;
      }(Parent);

      (0, _chai.expect)(Child.number()).to.equal(7);
      (0, _chai.expect)(Child.letter()).to.equal("A");
      (0, _chai.expect)(Child.name).to.equal("Child");
    });
  });

  describe("When a grandchild inherits", function () {
    it("Grandparent.onInherited is still called", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function Grandparent() {
          (0, _classCallCheck3.default)(this, Grandparent);
        }

        (0, _createClass3.default)(Grandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Grandparent;
      }();

      var Parent = function (_Grandparent) {
        var _Parent15 = function (_Grandparent2) {
          (0, _inherits3.default)(_Parent15, _Grandparent2);

          function _Parent15() {
            (0, _classCallCheck3.default)(this, _Parent15);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent15).apply(this, arguments));
          }

          return _Parent15;
        }(_Grandparent);

        var _Parent16 = _Parent15;

        if ("onInherited" in _Grandparent) {
          if (typeof _Grandparent.onInherited == 'function') {
            _Parent16 = _Grandparent.onInherited(_Parent15) || _Parent15;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Parent16 == 'function') {
          Object.defineProperty(_Parent16, "name", {
            value: 'Parent',
            configurable: true
          });
        }

        return _Parent16;
      }(Grandparent);

      var Child = function (_Parent17) {
        var _Child15 = function (_Parent18) {
          (0, _inherits3.default)(_Child15, _Parent18);

          function _Child15() {
            (0, _classCallCheck3.default)(this, _Child15);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child15).apply(this, arguments));
          }

          return _Child15;
        }(_Parent17);

        var _Child16 = _Child15;

        if ("onInherited" in _Parent17) {
          if (typeof _Parent17.onInherited == 'function') {
            _Child16 = _Parent17.onInherited(_Child15) || _Child15;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child16 == 'function') {
          Object.defineProperty(_Child16, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child16;
      }(Parent);

      (0, _chai.expect)(callback).to.have.been.calledWith(Parent);
      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("Grandparent.onInherited is not called if Parent redefined onInherited", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function Grandparent() {
          (0, _classCallCheck3.default)(this, Grandparent);
        }

        (0, _createClass3.default)(Grandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Grandparent;
      }();

      var Parent = function (_Grandparent3) {
        var _Parent19 = function (_Grandparent4) {
          (0, _inherits3.default)(_Parent19, _Grandparent4);

          function _Parent19() {
            (0, _classCallCheck3.default)(this, _Parent19);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent19).apply(this, arguments));
          }

          (0, _createClass3.default)(_Parent19, null, [{
            key: 'onInherited',
            value: function onInherited() {
              // do nothing
            }
          }]);
          return _Parent19;
        }(_Grandparent3);

        var _Parent20 = _Parent19;

        if ("onInherited" in _Grandparent3) {
          if (typeof _Grandparent3.onInherited == 'function') {
            _Parent20 = _Grandparent3.onInherited(_Parent19) || _Parent19;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Parent20 == 'function') {
          Object.defineProperty(_Parent20, "name", {
            value: 'Parent',
            configurable: true
          });
        }

        return _Parent20;
      }(Grandparent);

      var Child = function (_Parent21) {
        var _Child17 = function (_Parent22) {
          (0, _inherits3.default)(_Child17, _Parent22);

          function _Child17() {
            (0, _classCallCheck3.default)(this, _Child17);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child17).apply(this, arguments));
          }

          return _Child17;
        }(_Parent21);

        var _Child18 = _Child17;

        if ("onInherited" in _Parent21) {
          if (typeof _Parent21.onInherited == 'function') {
            _Child18 = _Parent21.onInherited(_Child17) || _Child17;
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        if (typeof _Child18 == 'function') {
          Object.defineProperty(_Child18, "name", {
            value: 'Child',
            configurable: true
          });
        }

        return _Child18;
      }(Parent);

      (0, _chai.expect)(callback).to.have.been.calledWith(Parent);
      (0, _chai.expect)(callback).not.to.have.been.calledWith(Child);
    });
  });
});